program mdr(input,output);

{This program generates a sparse molecular dynamics matrix 
which corresponds to md.nparticles.cutoffinv.densinv of the report
R. H. Bisseling and W. F. McColl,
Scientific Computing on Bulk Synchronous Parallel Architectures,
Preprint 836, Department of Mathematics, Utrecht University,
dec. 1993.

Usage: md matfile}

const points = 12000;
      dim = 3;

var C : array[1..points,1..dim] of real;
    matrix:text;
    d,n,j,ii,i,xseed,i1,i2,error:integer;
    x,y,cod,den,rr :real;

{WARNING you have to plug in your own random number generator instead of ran1}
function ran1(var idum: integer): real;


begin
    xseed:= wallclock 
    ;xseed:= xseed mod m1
    ;if xseed > 0 then xseed:= -xseed
    ;if xseed = 0 then xseed:= -1;

    rewrite(matrix);
    
    open(matrix,'^1','new',error);
    
    d:=3;
    
    writeln(output,'Input number of particles');
    read(n);
    
    writeln(output,'Input cut off distance 0 <= cod <= 1');
    read(cod);
    
    writeln(output,'Input density of long range interactions');
    read(den);
    
    writeln(matrix,'S', n,n);
    
    ii:=0;
    
    for i:=1 to n do
        for j:=1 to d do
            C[i,j]:=ran1(xseed);
    
    for i1:=1 to n do
        for i2:=i1 to n do
            begin
                x:=0.0;
                for j:=1 to d do
                    begin
                        y:=abs(C[i1,j] - C[i2,j]);
                        if y>0.5 then y:=1-y;
                        x:=x+sqr(y)
                    end;
                x:=sqrt(x);
                rr:=ran1(xseed);
                if ((x<=cod) or (rr<den)) then
                    begin
                        writeln(matrix,(i1-1):6,(i2-1):6,1.1:4:1);ii:=ii+1;
                        if i1 <> i2 then
                            begin
                                writeln(matrix,(i2-1):6,(i1-1):6,1.1:4:1);
                                ii:=ii+1
                            end;
                    end;
            end;
    
    writeln(matrix,-1);
    
    for i:=1 to n do
        begin
            write(matrix,i-1);
            for j:=1 to d do
                write(matrix,C[i,j]);
            writeln(matrix)
        end;
    
    
    close(matrix);
    writeln(output,'n is',n);
    writeln(output,'number of nonzeros is',ii);
    
    writeln(output,'density is',ii/sqr(n):7:3)
    
end.
